 REM file: Sic.inc v5.6a - Symbolic Instruction Code; include module.
 REM The public domain DOS programming interpreter.

 REM Version creation dates:
 REM 1.0a 05/11/1996
 REM 2.0a 05/20/1996
 REM 2.1a 05/24/1996
 REM 3.0a 05/26/1996
 REM 3.1a 05/29/1996
 REM 4.0a 06/10/1996
 REM 4.1a 07/16/1996
 REM 4.2a 08/03/1996
 REM 4.3a 08/07/1996
 REM 4.4a 08/14/1996
 REM 4.5a 12/06/1996
 REM 4.6a 01/21/1997
 REM 4.7a 02/19/1997
 REM 4.8a 04/14/1997
 REM 4.9a 05/22/1997
 REM 5.0a 06/04/1997
 REM 5.1a 11/22/1998
 REM 5.2a 12/06/1998
 REM 5.3a 12/28/1998
 REM 5.4a 01/08/1999
 REM 5.5a 01/15/1999
 REM 5.6a 03/08/1999

 REM Compiling with Microsoft BASIC Professional Development System 7.1:
 REM    bc sic/ah/fs/o/e;
 REM    bc sicsub1/ah/fs/o/e;
 REM    bc sicsub2/ah/fs/o/e;
 REM    link sic+sicsub1+sicsub2,sic.exe,Nul,library/e;
 REM
 REM Or run nmake on file makefile, or makefile.nmk.

 REM Library.lib is created with makelib.bat,
 REM    note: to create library.lib,
 REM    files dtfmter.lib and qbx.lib are required.
 REM Library.qlb is created with makeqlb.bat.
 REM    note: to create library.qlb,
 REM    files dtfmter.lib, qbx.lib, and qbxqlb.lib are required.

 REM To load Sic in Qbx, use QBX /L LIBRARY.QLB
 REM  then Alt-F, Open sic.bas,
 REM  then Qbx reads sicsub1.bas and sicsub2.bas from sic.mak
 REM  (if not, Alt-F, Load sicsub1.bas, Alt-F, Load sicsub2.bas).
 REM  Note: If Qbx runs out of string space, add /NOF to the command line.

 REM Include file declarations:

 REM $DYNAMIC
 DEFINT A-Z

 ' get include files
 REM $INCLUDE: 'qbx.bi'
 REM $INCLUDE: 'dta.bi'
 REM $INCLUDE: 'bpb.bi'

 ' boolean constants
 CONST Dfalse = 0#
 CONST Dtrue = -1#
 CONST False = 0
 CONST True = -1

 ' color constants
 CONST Black = 0
 CONST Plain = 7
 CONST Red = 12
 CONST White = 15
 CONST Yellow = 14

 ' constant declarations
 CONST Max.Lines = 2048
 CONST Nul = ""
 CONST Release = "a"
 CONST Version = "5.6"

 ' global variables
 COMMON SHARED Allow.Alpha AS INTEGER
 COMMON SHARED Array.Size AS INTEGER
 COMMON SHARED Assign AS INTEGER
 COMMON SHARED ASCIZ AS STRING * 260
 COMMON SHARED Branch1 AS STRING
 COMMON SHARED Branch2 AS STRING
 COMMON SHARED Branch.Index AS INTEGER
 COMMON SHARED Branch.Number AS INTEGER
 COMMON SHARED Branch.Type AS INTEGER
 COMMON SHARED CaseStrng AS STRING
 COMMON SHARED CaseValue AS DOUBLE
 COMMON SHARED CaseValue1 AS DOUBLE
 COMMON SHARED CaseValue2 AS DOUBLE
 COMMON SHARED CaseValueS1 AS STRING
 COMMON SHARED CaseValueS2 AS STRING
 COMMON SHARED DataLine AS INTEGER
 COMMON SHARED DataNumber AS INTEGER
 COMMON SHARED DataValue AS DOUBLE
 COMMON SHARED ErrorLine AS INTEGER
 COMMON SHARED ErrorType AS INTEGER
 COMMON SHARED ErrorValue AS INTEGER
 COMMON SHARED ExceptStep AS DOUBLE
 COMMON SHARED FieldVariable AS INTEGER
 COMMON SHARED Filename AS STRING
 COMMON SHARED FinishFor AS DOUBLE
 COMMON SHARED Last.Line AS INTEGER
 COMMON SHARED Last.Token AS INTEGER
 COMMON SHARED LineFeed AS INTEGER
 COMMON SHARED Max.Gosubs AS INTEGER
 COMMON SHARED Nested.Gosub AS INTEGER
 COMMON SHARED Out2 AS STRING
 COMMON SHARED Out3 AS STRING
 COMMON SHARED Out4 AS STRING
 COMMON SHARED Printing AS INTEGER
 COMMON SHARED Printer.LF AS INTEGER
 COMMON SHARED Program.Line AS INTEGER
 COMMON SHARED Program.Name AS STRING
 COMMON SHARED Program.Resume AS INTEGER
 COMMON SHARED Quotes AS INTEGER
 COMMON SHARED StepTo AS DOUBLE
 COMMON SHARED Screen.Mode AS INTEGER
 COMMON SHARED Strng AS STRING
 COMMON SHARED Token AS INTEGER
 COMMON SHARED Token.Index AS INTEGER
 COMMON SHARED Token.List AS STRING
 COMMON SHARED Unless.Branch AS INTEGER
 COMMON SHARED Unless.Value AS DOUBLE
 COMMON SHARED ValueIs AS DOUBLE
 COMMON SHARED Visible AS INTEGER
 COMMON SHARED Var.Seg1 AS STRING
 COMMON SHARED Var.Seg2 AS DOUBLE
 COMMON SHARED White.Space AS STRING

 ' common interrupt registers
 COMMON SHARED AX AS DOUBLE
 COMMON SHARED BX AS DOUBLE
 COMMON SHARED CX AS DOUBLE
 COMMON SHARED DX AS DOUBLE
 COMMON SHARED BP AS DOUBLE
 COMMON SHARED SI AS DOUBLE
 COMMON SHARED DI AS DOUBLE
 COMMON SHARED FL AS DOUBLE
 COMMON SHARED DS AS DOUBLE
 COMMON SHARED ES AS DOUBLE

 ' data areas
 COMMON SHARED Arrays() AS DOUBLE ' variable arrays A() to Z()
 COMMON SHARED ForNext() AS DOUBLE ' stack space for loops
 COMMON SHARED GosubReturn() AS INTEGER ' stack space for gosubs
 COMMON SHARED Strngs() AS STRING ' string variables A$ to Z$
 COMMON SHARED Variables() AS DOUBLE ' variables A to Z

 ' program areas
 COMMON SHARED Program() AS STRING
 COMMON SHARED Renumber.List() AS INTEGER

 ' file areas
 COMMON SHARED Field.Array() AS STRING
 COMMON SHARED File.Fields() AS STRING

 ' graphics areas
 COMMON SHARED Graphics.Screen() AS INTEGER
 COMMON SHARED Var.Seg3() AS INTEGER

 ' declare registers from qbx.lib
 COMMON SHARED InregsX AS RegTypeX, OutregsX AS RegTypeX

 ' declare program dta
 COMMON SHARED BASIC.DTA.SEG AS INTEGER, BASIC.DTA.OFF AS INTEGER
 COMMON SHARED BPBfile AS BPBtype

 ' subroutine declarations
 DECLARE SUB Analyze.Program ()
 DECLARE SUB Arith (T$, T1#, T2#)
 DECLARE SUB Assignment1 (T$, T%)
 DECLARE SUB Assignment2 (T$, T1%, T2%)
 DECLARE SUB Assignment3 (T$, T1$)
 DECLARE SUB Assignment4 (T$, T1$)
 DECLARE SUB Count.Lines (T%)
 DECLARE SUB Decrease.PSP ()
 DECLARE SUB Display.Error ()
 DECLARE SUB End.Program ()
 DECLARE SUB Enter.Equate ()
 DECLARE SUB Enter.Program.Line ()
 DECLARE SUB Equate (T#)
 DECLARE SUB Execute.Command (V$)
 DECLARE SUB Get.Token ()
 DECLARE SUB Get.Token2 (V%)
 DECLARE SUB Indent.Program ()
 DECLARE SUB Key.Prompt ()
 DECLARE SUB Kill.Program ()
 DECLARE SUB List.Files ()
 DECLARE SUB List.Help ()
 DECLARE SUB List.Help.File ()
 DECLARE SUB List.Program ()
 DECLARE SUB Load.Program ()
 DECLARE SUB More.Prompt (I1$, I2$, O$)
 DECLARE SUB New.Program ()
 DECLARE SUB Parse.Alphabetic1 (T#)
 DECLARE SUB Parse.Alphabetic2 (T#)
 DECLARE SUB Parse.Alphabetic3 (T#)
 DECLARE SUB Parse.Numeric (T#)
 DECLARE SUB Parse.Quoted ()
 DECLARE SUB Parse1 (T#)
 DECLARE SUB Parse2 (T#)
 DECLARE SUB Parse3 (T#)
 DECLARE SUB Parse4 (T#)
 DECLARE SUB Parse5 (T#)
 DECLARE SUB Parse6 (T#)
 DECLARE SUB Parse7 (T#)
 DECLARE SUB Parse8 (T#)
 DECLARE SUB Parse9 (T#)
 DECLARE SUB Print.Output ()
 DECLARE SUB Quit.Program ()
 DECLARE SUB Read.Data.Element (T%)
 DECLARE SUB Read.Program ()
 DECLARE SUB Read.Stdin ()
 DECLARE SUB Renumber.Program ()
 DECLARE SUB Run.Program ()
 DECLARE SUB Save.Current ()
 DECLARE SUB Save.Program ()
 DECLARE SUB Store.Program ()
 DECLARE SUB Whatis.Command ()

 ' function declarations from dtfmter.lib
 DECLARE FUNCTION NOW# ()
 DECLARE FUNCTION FORMATD$ (BYVAL S#, B$)
 DECLARE FUNCTION STRIM$ (S$)

